package ch.zhaw.pm2.racetrack;

import ch.zhaw.pm2.racetrack.strategy.MoveListStrategy;
import ch.zhaw.pm2.racetrack.strategy.MoveStrategy;
import org.junit.jupiter.api.*;

import java.io.File;
import java.io.FileNotFoundException;

/**
 * This Class tests the MoveStrategy.
 */
public class MoveListStrategyTest {

    private MoveStrategy moveList;


    @Nested
    @DisplayName("MoveListStrategy")
    class MoveList {

        /**
         * Creates a new MoveListStrategy
         */
        @BeforeEach
        void setup() {
            try {
                moveList = new MoveListStrategy(new File(".\\moves\\challenge-car-a.txt"));
            }catch (FileNotFoundException | InvalidFileFormatException e) {
                e.printStackTrace();
            }
        }

        /**
         * Checks if the directions are returned correct by method nextMove
         */
        @Test
        void checkMove() {
            Assertions.assertEquals(PositionVector.Direction.RIGHT,moveList.nextMove());
            for (int i = 0; i < 3; i++) {
                moveList.nextMove();
            }
            Assertions.assertEquals(PositionVector.Direction.NONE,moveList.nextMove());
            for (int i = 0; i < 40; i++) {
                moveList.nextMove();
            }
            Assertions.assertNull(moveList.nextMove());
        }
    }
}
